diff --git a/salt/utils/xmlutil.py b/salt/utils/xmlutil.py
index 6d8d74fd3f..2b9c7bf43f 100644
--- a/salt/utils/xmlutil.py
+++ b/salt/utils/xmlutil.py
@@ -1,30 +1,34 @@
-# -*- coding: utf-8 -*-
-'''
+"""
 Various XML utilities
-'''
+"""
 
 # Import Python libs
-from __future__ import absolute_import, print_function, unicode_literals
+import re
+import string  # pylint: disable=deprecated-module
+from xml.etree import ElementTree
+
+# Import salt libs
+import salt.utils.data
 
 
 def _conv_name(x):
-    '''
+    """
     If this XML tree has an xmlns attribute, then etree will add it
     to the beginning of the tag, like: "{http://path}tag".
-    '''
-    if '}' in x:
-        comps = x.split('}')
+    """
+    if "}" in x:
+        comps = x.split("}")
         name = comps[1]
         return name
     return x
 
 
 def _to_dict(xmltree):
-    '''
+    """
     Converts an XML ElementTree to a dictionary that only contains items.
     This is the default behavior in version 2017.7. This will default to prevent
     unexpected parsing issues on modules dependant on this.
-    '''
+    """
     # If this object has no children, the for..loop below will return nothing
     # for it, so just return a single dict representing it.
     if len(xmltree.getchildren()) < 1:
@@ -51,9 +55,9 @@ def _to_dict(xmltree):
 
 
 def _to_full_dict(xmltree):
-    '''
+    """
     Returns the full XML dictionary including attributes.
-    '''
+    """
     xmldict = {}
 
     for attrName, attrValue in xmltree.attrib.items():
@@ -87,15 +91,234 @@ def _to_full_dict(xmltree):
 
 
 def to_dict(xmltree, attr=False):
-    '''
+    """
     Convert an XML tree into a dict. The tree that is passed in must be an
     ElementTree object.
     Args:
         xmltree: An ElementTree object.
         attr: If true, attributes will be parsed. If false, they will be ignored.
 
-    '''
+    """
     if attr:
         return _to_full_dict(xmltree)
     else:
         return _to_dict(xmltree)
+
+
+def get_xml_node(node, xpath):
+    """
+    Get an XML node using a path (super simple xpath showing complete node ancestry).
+    This also creates the missing nodes.
+
+    The supported XPath can contain elements filtering using [@attr='value'].
+
+    Args:
+        node: an Element object
+        xpath: simple XPath to look for.
+    """
+    if not xpath.startswith("./"):
+        xpath = "./{}".format(xpath)
+    res = node.find(xpath)
+    if res is None:
+        parent_xpath = xpath[: xpath.rfind("/")]
+        parent = node.find(parent_xpath)
+        if parent is None:
+            parent = get_xml_node(node, parent_xpath)
+        segment = xpath[xpath.rfind("/") + 1 :]
+        # We may have [] filter in the segment
+        matcher = re.match(
+            r"""(?P<tag>[^[]+)(?:\[@(?P<attr>\w+)=["'](?P<value>[^"']+)["']])?""",
+            segment,
+        )
+        attrib = (
+            {matcher.group("attr"): matcher.group("value")}
+            if matcher.group("attr") and matcher.group("value")
+            else {}
+        )
+        res = ElementTree.SubElement(parent, matcher.group("tag"), attrib)
+    return res
+
+
+def set_node_text(node, value):
+    """
+    Function to use in the ``set`` value in the :py:func:`change_xml` mapping items to set the text.
+    This is the default.
+
+    :param node: the node to set the text to
+    :param value: the value to set
+    """
+    node.text = str(value)
+
+
+def clean_node(parent_map, node, ignored=None):
+    """
+    Remove the node from its parent if it has no attribute but the ignored ones, no text and no child.
+    Recursively called up to the document root to ensure no empty node is left.
+
+    :param parent_map: dictionary mapping each node to its parent
+    :param node: the node to clean
+    :param ignored: a list of ignored attributes.
+    """
+    has_text = node.text is not None and node.text.strip()
+    parent = parent_map.get(node)
+    if (
+        len(node.attrib.keys() - (ignored or [])) == 0
+        and not list(node)
+        and not has_text
+    ):
+        parent.remove(node)
+    # Clean parent nodes if needed
+    if parent is not None:
+        clean_node(parent_map, parent, ignored)
+
+
+def del_text(parent_map, node):
+    """
+    Function to use as ``del`` value in the :py:func:`change_xml` mapping items to remove the text.
+    This is the default function.
+    Calls :py:func:`clean_node` before returning.
+    """
+    parent = parent_map[node]
+    parent.remove(node)
+    clean_node(parent, node)
+
+
+def del_attribute(attribute, ignored=None):
+    """
+    Helper returning a function to use as ``del`` value in the :py:func:`change_xml` mapping items to
+    remove an attribute.
+
+    The generated function calls :py:func:`clean_node` before returning.
+
+    :param attribute: the name of the attribute to remove
+    :param ignored: the list of attributes to ignore during the cleanup
+
+    :return: the function called by :py:func:`change_xml`.
+    """
+
+    def _do_delete(parent_map, node):
+        if attribute not in node.keys():
+            return
+        node.attrib.pop(attribute)
+        clean_node(parent_map, node, ignored)
+
+    return _do_delete
+
+
+def change_xml(doc, data, mapping):
+    """
+    Change an XML ElementTree document according.
+
+    :param doc: the ElementTree parsed XML document to modify
+    :param data: the dictionary of values used to modify the XML.
+    :param mapping: a list of items describing how to modify the XML document.
+        Each item is a dictionary containing the following keys:
+
+        .. glossary::
+            path
+                the path to the value to set or remove in the ``data`` parameter.
+                See :py:func:`salt.utils.data.get_value <salt.utils.data.get_value>` for the format
+                of the value.
+
+            xpath
+                Simplified XPath expression used to locate the change in the XML tree.
+                See :py:func:`get_xml_node` documentation for details on the supported XPath syntax
+
+            get
+                function gettin the value from the XML.
+                Takes a single parameter for the XML node found by the XPath expression.
+                Default returns the node text value.
+                This may be used to return an attribute or to perform value transformation.
+
+            set
+                function setting the value in the XML.
+                Takes two parameters for the XML node and the value to set.
+                Default is to set the text value.
+
+            del
+                function deleting the value in the XML.
+                Takes two parameters for the parent node and the node matched by the XPath.
+                Default is to remove the text value.
+                More cleanup may be performed, see the :py:func:`clean_node` function for details.
+
+            convert
+                function modifying the user-provided value right before comparing it with the one from the XML.
+                Takes the value as single parameter.
+                Default is to apply no conversion.
+
+    :return: ``True`` if the XML has been modified, ``False`` otherwise.
+    """
+    need_update = False
+    for param in mapping:
+        # Get the value from the function parameter using the path-like description
+        # Using an empty list as a default value will cause values not provided by the user
+        # to be left untouched, as opposed to explicit None unsetting the value
+        values = salt.utils.data.get_value(data, param["path"], [])
+        xpath = param["xpath"]
+        # Prepend the xpath with ./ to handle the root more easily
+        if not xpath.startswith("./"):
+            xpath = "./{}".format(xpath)
+
+        placeholders = [
+            s[1:-1]
+            for s in param["path"].split(":")
+            if s.startswith("{") and s.endswith("}")
+        ]
+
+        ctx = {placeholder: "$$$" for placeholder in placeholders}
+        all_nodes_xpath = string.Template(xpath).substitute(ctx)
+        all_nodes_xpath = re.sub(
+            r"""(?:=['"]\$\$\$["'])|(?:\[\$\$\$\])""", "", all_nodes_xpath
+        )
+
+        # Store the nodes that are not removed for later cleanup
+        kept_nodes = set()
+
+        for value_item in values:
+            new_value = value_item["value"]
+
+            # Only handle simple type values. Use multiple entries or a custom get for dict or lists
+            if isinstance(new_value, list) or isinstance(new_value, dict):
+                continue
+
+            if new_value is not None:
+                ctx = {
+                    placeholder: value_item.get(placeholder, "")
+                    for placeholder in placeholders
+                }
+                node_xpath = string.Template(xpath).substitute(ctx)
+                node = get_xml_node(doc, node_xpath)
+
+                kept_nodes.add(node)
+
+                get_fn = param.get("get", lambda n: n.text)
+                set_fn = param.get("set", set_node_text)
+                current_value = get_fn(node)
+
+                # Do we need to apply some conversion to the user-provided value?
+                convert_fn = param.get("convert")
+                if convert_fn:
+                    new_value = convert_fn(new_value)
+
+                if current_value != new_value:
+                    set_fn(node, new_value)
+                    need_update = True
+            else:
+                nodes = doc.findall(all_nodes_xpath)
+                del_fn = param.get("del", del_text)
+                parent_map = {c: p for p in doc.iter() for c in p}
+                for node in nodes:
+                    del_fn(parent_map, node)
+                    need_update = True
+
+        # Clean the left over XML elements if there were placeholders
+        if placeholders and values[0].get("value") != []:
+            all_nodes = set(doc.findall(all_nodes_xpath))
+            to_remove = all_nodes - kept_nodes
+            del_fn = param.get("del", del_text)
+            parent_map = {c: p for p in doc.iter() for c in p}
+            for node in to_remove:
+                del_fn(parent_map, node)
+                need_update = True
+
+    return need_update
diff --git a/tests/pytests/unit/utils/test_data.py b/tests/pytests/unit/utils/test_data.py
new file mode 100644
index 0000000000..b3f0ba04ae
--- /dev/null
+++ b/tests/pytests/unit/utils/test_data.py
@@ -0,0 +1,57 @@
+import salt.utils.data
+
+
+def test_get_value_simple_path():
+    data = {"a": {"b": {"c": "foo"}}}
+    assert [{"value": "foo"}] == salt.utils.data.get_value(data, "a:b:c")
+
+
+def test_get_value_placeholder_dict():
+    data = {"a": {"b": {"name": "foo"}, "c": {"name": "bar"}}}
+    assert [
+        {"value": "foo", "id": "b"},
+        {"value": "bar", "id": "c"},
+    ] == salt.utils.data.get_value(data, "a:{id}:name")
+
+
+def test_get_value_placeholder_list():
+    data = {"a": [{"name": "foo"}, {"name": "bar"}]}
+    assert [
+        {"value": "foo", "id": 0},
+        {"value": "bar", "id": 1},
+    ] == salt.utils.data.get_value(data, "a:{id}:name")
+
+
+def test_get_value_nested_placeholder():
+    data = {
+        "a": {
+            "b": {"b1": {"name": "foo1"}, "b2": {"name": "foo2"}},
+            "c": {"c1": {"name": "bar"}},
+        }
+    }
+    assert [
+        {"value": "foo1", "id": "b", "sub": "b1"},
+        {"value": "foo2", "id": "b", "sub": "b2"},
+        {"value": "bar", "id": "c", "sub": "c1"},
+    ] == salt.utils.data.get_value(data, "a:{id}:{sub}:name")
+
+
+def test_get_value_nested_notfound():
+    data = {"a": {"b": {"c": "foo"}}}
+    assert [{"value": []}] == salt.utils.data.get_value(data, "a:b:d", [])
+
+
+def test_get_value_not_found():
+    assert [{"value": []}] == salt.utils.data.get_value({}, "a", [])
+
+
+def test_get_value_none():
+    assert [{"value": None}] == salt.utils.data.get_value({"a": None}, "a")
+
+
+def test_get_value_simple_type_path():
+    assert [{"value": []}] == salt.utils.data.get_value({"a": 1024}, "a:b", [])
+
+
+def test_get_value_None_path():
+    assert [{"value": None}] == salt.utils.data.get_value({"a": None}, "a:b", [])
diff --git a/tests/pytests/unit/utils/test_xmlutil.py b/tests/pytests/unit/utils/test_xmlutil.py
new file mode 100644
index 0000000000..081cc64193
--- /dev/null
+++ b/tests/pytests/unit/utils/test_xmlutil.py
@@ -0,0 +1,169 @@
+import pytest
+import salt.utils.xmlutil as xml
+from salt._compat import ElementTree as ET
+
+
+@pytest.fixture
+def xml_doc():
+    return ET.fromstring(
+        """
+        <domain>
+            <name>test01</name>
+            <memory unit="MiB">1024</memory>
+            <cpu>
+                <topology sockets="1"/>
+            </cpu>
+            <vcpus>
+              <vcpu enabled="yes" id="1"/>
+            </vcpus>
+        </domain>
+    """
+    )
+
+
+def test_change_xml_text(xml_doc):
+    ret = xml.change_xml(
+        xml_doc, {"name": "test02"}, [{"path": "name", "xpath": "name"}]
+    )
+    assert ret
+    assert "test02" == xml_doc.find("name").text
+
+
+def test_change_xml_text_nochange(xml_doc):
+    ret = xml.change_xml(
+        xml_doc, {"name": "test01"}, [{"path": "name", "xpath": "name"}]
+    )
+    assert not ret
+
+
+def test_change_xml_text_notdefined(xml_doc):
+    ret = xml.change_xml(xml_doc, {}, [{"path": "name", "xpath": "name"}])
+    assert not ret
+
+
+def test_change_xml_text_removed(xml_doc):
+    ret = xml.change_xml(xml_doc, {"name": None}, [{"path": "name", "xpath": "name"}])
+    assert ret
+    assert xml_doc.find("name") is None
+
+
+def test_change_xml_text_add(xml_doc):
+    ret = xml.change_xml(
+        xml_doc,
+        {"cpu": {"vendor": "ACME"}},
+        [{"path": "cpu:vendor", "xpath": "cpu/vendor"}],
+    )
+    assert ret
+    assert "ACME" == xml_doc.find("cpu/vendor").text
+
+
+def test_change_xml_convert(xml_doc):
+    ret = xml.change_xml(
+        xml_doc,
+        {"mem": 2},
+        [{"path": "mem", "xpath": "memory", "convert": lambda v: v * 1024}],
+    )
+    assert ret
+    assert "2048" == xml_doc.find("memory").text
+
+
+def test_change_xml_attr(xml_doc):
+    ret = xml.change_xml(
+        xml_doc,
+        {"cpu": {"topology": {"cores": 4}}},
+        [
+            {
+                "path": "cpu:topology:cores",
+                "xpath": "cpu/topology",
+                "get": lambda n: int(n.get("cores")) if n.get("cores") else None,
+                "set": lambda n, v: n.set("cores", str(v)),
+                "del": xml.del_attribute("cores"),
+            }
+        ],
+    )
+    assert ret
+    assert "4" == xml_doc.find("cpu/topology").get("cores")
+
+
+def test_change_xml_attr_unchanged(xml_doc):
+    ret = xml.change_xml(
+        xml_doc,
+        {"cpu": {"topology": {"sockets": 1}}},
+        [
+            {
+                "path": "cpu:topology:sockets",
+                "xpath": "cpu/topology",
+                "get": lambda n: int(n.get("sockets")) if n.get("sockets") else None,
+                "set": lambda n, v: n.set("sockets", str(v)),
+                "del": xml.del_attribute("sockets"),
+            }
+        ],
+    )
+    assert not ret
+
+
+def test_change_xml_attr_remove(xml_doc):
+    ret = xml.change_xml(
+        xml_doc,
+        {"cpu": {"topology": {"sockets": None}}},
+        [
+            {
+                "path": "cpu:topology:sockets",
+                "xpath": "./cpu/topology",
+                "get": lambda n: int(n.get("sockets")) if n.get("sockets") else None,
+                "set": lambda n, v: n.set("sockets", str(v)),
+                "del": xml.del_attribute("sockets"),
+            }
+        ],
+    )
+    assert ret
+    assert xml_doc.find("cpu") is None
+
+
+def test_change_xml_not_simple_value(xml_doc):
+    ret = xml.change_xml(
+        xml_doc,
+        {"cpu": {"topology": {"sockets": None}}},
+        [{"path": "cpu", "xpath": "vcpu", "get": lambda n: int(n.text)}],
+    )
+    assert not ret
+
+
+def test_change_xml_template(xml_doc):
+    ret = xml.change_xml(
+        xml_doc,
+        {"cpu": {"vcpus": {2: {"enabled": True}, 4: {"enabled": False}}}},
+        [
+            {
+                "path": "cpu:vcpus:{id}:enabled",
+                "xpath": "vcpus/vcpu[@id='$id']",
+                "convert": lambda v: "yes" if v else "no",
+                "get": lambda n: n.get("enabled"),
+                "set": lambda n, v: n.set("enabled", v),
+                "del": xml.del_attribute("enabled", ["id"]),
+            },
+        ],
+    )
+    assert ret
+    assert xml_doc.find("vcpus/vcpu[@id='1']") is None
+    assert "yes" == xml_doc.find("vcpus/vcpu[@id='2']").get("enabled")
+    assert "no" == xml_doc.find("vcpus/vcpu[@id='4']").get("enabled")
+
+
+def test_change_xml_template_remove(xml_doc):
+    ret = xml.change_xml(
+        xml_doc,
+        {"cpu": {"vcpus": None}},
+        [
+            {
+                "path": "cpu:vcpus:{id}:enabled",
+                "xpath": "vcpus/vcpu[@id='$id']",
+                "convert": lambda v: "yes" if v else "no",
+                "get": lambda n: n.get("enabled"),
+                "set": lambda n, v: n.set("enabled", v),
+                "del": xml.del_attribute("enabled", ["id"]),
+            },
+        ],
+    )
+    assert ret
+    assert xml_doc.find("vcpus") is None
